#include "sprite.h"

// Constructor
Sprite::Sprite(int x, int y, int w, int h, LTexture *texture, SDL_Renderer *renderer)
{
	// Establece la posición X,Y del sprite
	this->x = x;
	this->y = y;

	// Establece el alto y el ancho del sprite
	this->w = w;
	this->h = h;

	// Establece el puntero al renderizador de la ventana
	this->renderer = renderer;

	// Establece la textura donde están los gráficos para el sprite
	this->texture = texture;

	// Establece el rectangulo de donde coger la imagen
	spriteClip = {x, y, w, h};

	// Inicializa variables
	enabled = true;
}

Sprite::Sprite(SDL_Rect rect, LTexture *texture, SDL_Renderer *renderer)
{
	// Establece la posición X,Y del sprite
	x = rect.x;
	y = rect.y;

	// Establece el alto y el ancho del sprite
	w = rect.w;
	h = rect.h;

	// Establece el puntero al renderizador de la ventana
	this->renderer = renderer;

	// Establece la textura donde están los gráficos para el sprite
	this->texture = texture;

	// Establece el rectangulo de donde coger la imagen
	spriteClip = {x, y, w, h};

	// Inicializa variables
	enabled = true;
}

// Destructor
Sprite::~Sprite()
{
	texture = nullptr;
	renderer = nullptr;
}

// Muestra el sprite por pantalla
void Sprite::render()
{
	if (enabled)
	{
		texture->render(renderer, x, y, &spriteClip);
	}
}

// Obten el valor de la variable
int Sprite::getPosX()
{
	return x;
}

// Obten el valor de la variable
int Sprite::getPosY()
{
	return y;
}

// Obten el valor de la variable
int Sprite::getWidth()
{
	return w;
}

// Obten el valor de la variable
int Sprite::getHeight()
{
	return h;
}

// Establece la posición del objeto
void Sprite::setPos(SDL_Rect rect)
{
	x = rect.x;
	y = rect.y;
}

// Establece el valor de la variable
void Sprite::setPosX(int x)
{
	this->x = x;
}

// Establece el valor de la variable
void Sprite::setPosY(int y)
{
	this->y = y;
}

// Incrementa el valor de la variable
void Sprite::incPosX(int value)
{
	x += value;
}

// Incrementa el valor de la variable
void Sprite::incPosY(int value)
{
	y += value;
}

// Establece el valor de la variable
void Sprite::setWidth(int w)
{
	this->w = w;
}

// Establece el valor de la variable
void Sprite::setHeight(int h)
{
	this->h = h;
}

// Obten el valor de la variable
SDL_Rect Sprite::getSpriteClip()
{
	return spriteClip;
}

// Establece el valor de la variable
void Sprite::setSpriteClip(SDL_Rect rect)
{
	spriteClip = rect;
}

// Establece el valor de la variable
void Sprite::setSpriteClip(int x, int y, int w, int h)
{
	spriteClip = {x, y, w, h};
}

// Obten el valor de la variable
LTexture *Sprite::getTexture()
{
	return texture;
}

// Establece el valor de la variable
void Sprite::setTexture(LTexture *texture)
{
	this->texture = texture;
}

// Establece el valor de la variable
void Sprite::setRenderer(SDL_Renderer *renderer)
{
	this->renderer = renderer;
}

// Establece el valor de la variable
void Sprite::setEnabled(bool value)
{
	enabled = value;
}

// Comprueba si el objeto está habilitado
bool Sprite::isEnabled()
{
	return enabled;
}

// Devuelve el rectangulo donde está el sprite
SDL_Rect Sprite::getRect()
{
	SDL_Rect rect = {x, y, w, h};
	return rect;
}

// Establece los valores de posición y tamaño del sprite
void Sprite::setRect(SDL_Rect rect)
{
	x = rect.x;
	y = rect.y;
	w = rect.w;
	h = rect.h;
}